using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.IO;

public partial class _Default : System.Web.UI.Page 
{

    private string[] searchPatterns = { "*.asp", "*.htm", "*.html" };
    private const string directoryToSearch = ".";


    
    private void InitFiles()
		{
			ddlAvailableFiles.Items.Clear();
			for(int j = 0; j<searchPatterns.Length; j++)
			{
				string[] files = Directory.GetFiles(Server.MapPath(directoryToSearch), searchPatterns[j]);
				for(int i=0; i<files.Length; i++)
				{
					if("*" + Path.GetExtension(files[i]) == searchPatterns[j])
					{
						ddlAvailableFiles.Items.Add(new ListItem(files[i]));
					}
				}
			}
		}
    protected void btnLoad_Click(object sender, EventArgs e)
    {
        if (ddlAvailableFiles.SelectedIndex < 0)
        {
            //TODO: some error message displaying can be added here
            return;
        }
        if (!File.Exists(ddlAvailableFiles.SelectedItem.Value))
        {
            //TODO: some error message displaying can be added here
            return;
        }
        string wholeFile = "";
        try
        {
            //read the whole file
            StreamReader sr = File.OpenText(ddlAvailableFiles.SelectedItem.Value);
            wholeFile = sr.ReadToEnd();
            sr.Close();
        }
        catch (Exception ex)
        {
            Response.Write("The following error occured: " + ex.Message);
            return;
        }

        //get the text before that to edit and the text after it
        int startIndex = wholeFile.LastIndexOf(txtFromTag.Text) + txtFromTag.Text.Length;
        int endIndex = wholeFile.IndexOf(txtToTag.Text);
        if ((startIndex > 0) && startIndex < wholeFile.Length)
        {
            ViewState["CurrentHeader"] = wholeFile.Substring(0, startIndex);
        }
        else
        {
            ViewState["CurrentHeader"] = "";
        }
        if ((endIndex - startIndex > 0) && (endIndex - startIndex < wholeFile.Length - startIndex))
        {
            ViewState["CurrentFooter"] = wholeFile.Substring(endIndex);
        }
        else
        {
            ViewState["CurrentFooter"] = "";
        }
        if ((endIndex > 0) && (endIndex < wholeFile.Length))
        {
            ViewState["CurrentFooter"] = wholeFile.Substring(endIndex);
        }
        else
        {
            ViewState["CurrentFooter"] = "";
        }
        //assign the text to edit to the editor
        if ((startIndex > 0) && (endIndex - startIndex > 0) && (endIndex - startIndex < wholeFile.Length - startIndex))
        {
            editorMain.Content = wholeFile.Substring(startIndex, endIndex - startIndex);
        }
        //set the filename to save to the textbox for convenience
        txtNewFileName.Text = Path.GetFileName(ddlAvailableFiles.SelectedItem.Value);
    }
    protected void btnSave_Click(object sender, EventArgs e)
    {
        if (txtNewFileName.Text == "")
        {
            //TODO: add here an error reporting routine
            return;
        }
        string header = "";
        string footer = "";
        if (ViewState["CurrentHeader"] != null)
        {
            header = ViewState["CurrentHeader"].ToString();
        }
        if (ViewState["CurrentFooter"] != null)
        {
            footer = ViewState["CurrentFooter"].ToString();
        }
        try
        {
            StreamWriter sw = File.CreateText(Server.MapPath(directoryToSearch) + Path.DirectorySeparatorChar + txtNewFileName.Text);
            sw.Write(header.ToString() + editorMain.Html + footer.ToString());
            sw.Close();
            InitFiles();
        }
        catch (Exception ex)
        {
            Response.Write("An error occured while saving. Error details: " + ex.Message);
        }
        editorMain.Html = "";
        txtNewFileName.Text = "";
    }
    protected void Page_Load(object sender, EventArgs e)
    {
			if(Page.IsPostBack == false)
			{
				InitFiles();
			}
    }
}
