Imports System
Imports System.Data
Imports System.Configuration
Imports System.Web
Imports System.Web.Security
Imports System.Web.UI
Imports System.Web.UI.WebControls
Imports System.Web.UI.WebControls.WebParts
Imports System.Web.UI.HtmlControls
Imports System.IO

Partial Public Class _DefaultVB
    Inherits System.Web.UI.Page

    Private searchPatterns As String() = {"*.asp", "*.htm", "*.html"}
    Private Const directoryToSearch As String = "."



    Private Sub InitFiles()
        ddlAvailableFiles.Items.Clear()
        Dim j As Integer = 0
        While j < searchPatterns.Length
            Dim files As String() = Directory.GetFiles(Server.MapPath(directoryToSearch), searchPatterns(j))
            Dim i As Integer = 0
            While i < files.Length
                If "*" + Path.GetExtension(files(i)) = searchPatterns(j) Then
                    ddlAvailableFiles.Items.Add(New ListItem(files(i)))
                End If
                System.Math.Max(System.Threading.Interlocked.Increment(i), i - 1)
            End While
            System.Math.Max(System.Threading.Interlocked.Increment(j), j - 1)
        End While
    End Sub
    Protected Sub btnLoad_Click(ByVal sender As Object, ByVal e As EventArgs)
        If ddlAvailableFiles.SelectedIndex < 0 Then
            'TODO: some error message displaying can be added here
            Return
        End If
        If Not File.Exists(ddlAvailableFiles.SelectedItem.Value) Then
            'TODO: some error message displaying can be added here
            Return
        End If
        Dim wholeFile As String = ""
        Try
            'read the whole file
            Dim sr As StreamReader = File.OpenText(ddlAvailableFiles.SelectedItem.Value)
            wholeFile = sr.ReadToEnd()
            sr.Close()
        Catch ex As Exception
            Response.Write("The following error occured: " + ex.Message)
            Return
        End Try

        'get the text before that to edit and the text after it
        Dim startIndex As Integer = wholeFile.LastIndexOf(txtFromTag.Text) + txtFromTag.Text.Length
        Dim endIndex As Integer = wholeFile.IndexOf(txtToTag.Text)
        If (startIndex > 0) AndAlso startIndex < wholeFile.Length Then
            ViewState("CurrentHeader") = wholeFile.Substring(0, startIndex)
        Else
            ViewState("CurrentHeader") = ""
        End If
        If (endIndex - startIndex > 0) AndAlso (endIndex - startIndex < wholeFile.Length - startIndex) Then
            ViewState("CurrentFooter") = wholeFile.Substring(endIndex)
        Else
            ViewState("CurrentFooter") = ""
        End If
        If (endIndex > 0) AndAlso (endIndex < wholeFile.Length) Then
            ViewState("CurrentFooter") = wholeFile.Substring(endIndex)
        Else
            ViewState("CurrentFooter") = ""
        End If
        'assign the text to edit to the editor
        If (startIndex > 0) AndAlso (endIndex - startIndex > 0) AndAlso (endIndex - startIndex < wholeFile.Length - startIndex) Then
            editorMain.Content = wholeFile.Substring(startIndex, endIndex - startIndex)
        End If
        'set the filename to save to the textbox for convenience
        txtNewFileName.Text = Path.GetFileName(ddlAvailableFiles.SelectedItem.Value)
    End Sub
    Protected Sub btnSave_Click(ByVal sender As Object, ByVal e As EventArgs)
        If txtNewFileName.Text = "" Then
            'TODO: add here an error reporting routine
            Return
        End If
        Dim header As String = ""
        Dim footer As String = ""
        If ViewState("CurrentHeader") <> Nothing Then
            header = ViewState("CurrentHeader").ToString()
        End If
        If ViewState("CurrentFooter") <> Nothing Then
            footer = ViewState("CurrentFooter").ToString()
        End If
        Try
            Dim sw As StreamWriter = File.CreateText(Server.MapPath(directoryToSearch) + Path.DirectorySeparatorChar + txtNewFileName.Text)
            sw.Write(header.ToString() + editorMain.Html + footer.ToString())
            sw.Close()
            InitFiles()
        Catch ex As Exception
            Response.Write("An error occured while saving. Error details: " + ex.Message)
        End Try
        editorMain.Html = ""
        txtNewFileName.Text = ""
    End Sub
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs)
        If Page.IsPostBack = False Then
            InitFiles()
        End If
    End Sub
End Class

'=======================================================
'Service provided by Telerik (www.telerik.com)
'Conversion powered by NRefactory.
'Built and maintained by Todd Anglin and Telerik
'=======================================================
